// DumpWindow.cpp :  Դϴ.
//

#include "stdafx.h"
#include "ATPlugin.h"
#include "DumpWindow.h"
#include "tstring.h"
#include "SubFunc.h"

volatile bool g_bRunning;
CWinThread * g_pThread;
CCriticalSection g_cs;
CStringList g_arText;

// CDumpWindow ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDumpWindow, CDialog)

CDumpWindow::CDumpWindow(int WindowN,CWnd* pParent /*=NULL*/)
	: CDialog(CDumpWindow::IDD, pParent)
	, m_bLoad(false)
	, m_nWindowN(WindowN)
{
	// 
	g_bRunning=true;
	g_pThread = AfxBeginThread(CDumpWindow::ThreadFunc,this,THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	if(g_pThread)
		g_pThread->ResumeThread();
}

CDumpWindow::~CDumpWindow()
{
	g_cs.Lock();
	g_bRunning=false;
	g_cs.Unlock();
	if(NULL != g_pThread)
	{
		::WaitForSingleObject(g_pThread->m_hThread,INFINITE);
		delete g_pThread;
		g_pThread = NULL;
	}
}

void CDumpWindow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RichEdit, m_ctrRich);
}

BOOL CDumpWindow::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_bLoad=true;

	g_cs.Lock();
	m_ctrRich.LimitText(-1);

	m_Size= CRect(
		g_cOption.GetOptionInt(L"Pos",m_nWindowN,1),
		g_cOption.GetOptionInt(L"Pos",m_nWindowN,2),
		g_cOption.GetOptionInt(L"Pos",m_nWindowN,3),
		g_cOption.GetOptionInt(L"Pos",m_nWindowN,4));


	if(m_Size.IsRectNull())
	{
		 GetWindowRect(m_Size);
	}
	MoveWindow(m_Size);
	g_cs.Unlock();

	SetTop();
	SetDFont();

	return FALSE;
}

BEGIN_MESSAGE_MAP(CDumpWindow, CDialog)
	ON_WM_SIZE()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

void CDumpWindow::PostNcDestroy()
{
	delete this;
	CDialog::PostNcDestroy();
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

void CDumpWindow::SetTop(int bTop)
{
	if(bTop!=-1)
	{
		g_cOption.SetOptionInt(L"Top",m_nWindowN,bTop);
	}

	if(g_cOption.GetOptionBool(L"Top",m_nWindowN))
	{
		::SetWindowPos(m_hWnd, HWND_TOPMOST, 0, 0, 0, 0,
                                          SWP_NOMOVE|SWP_NOSIZE); 
	}
	else
	{
		::SetWindowPos(m_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
                                          SWP_NOMOVE|SWP_NOSIZE); 
	}
}

void CDumpWindow::OnSize(UINT nType, int cx, int cy)
{
	g_cs.Lock();

	CDialog::OnSize(nType, cx, cy);

	if(m_bLoad)
	{
		m_ctrRich.MoveWindow(0,0,cx,cy);
	}
	g_cs.Unlock();
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}


UINT CDumpWindow::ThreadFunc(LPVOID param)
{
	//RichEdit  ߰ (http://zeroplus.tistory.com/28)
	//׻ Ǵ ڿ ̸̸
	SETTEXTEX settextex;
	settextex.flags = ST_SELECTION;
	settextex.codepage = 1200;

	CDumpWindow * pDump = static_cast<CDumpWindow*>(param);
	CWnd * pRich = pDump->GetDlgItem(IDC_RichEdit);
	while(1)
	{
		g_cs.Lock();
		if(!g_bRunning)
		{
			g_cs.Unlock();
			break;
		}
		else
		{
			while(IsWindow(pRich->m_hWnd) && !g_arText.IsEmpty())
			{
				// settextex ü Ĵ ؽƮ ġƮ Ʈѿ Էմϴ.
				pRich->SendMessage(EM_SETTEXTEX, (WPARAM) &settextex, (LPARAM)g_arText.GetHead().GetString());

				// ߰  ؼ ü    : 1-based ε 
				int nLines = (int) pRich->SendMessage(EM_GETLINECOUNT, 0, 0 );

				//  ̴ ù °  Ű ε ȯ : 0-based ε 
				int nVisibleLine = (int) pRich->SendMessage(EM_GETFIRSTVISIBLELINE, 0, 0 );

				// ڿ ߰ƴٰ ؼ, ũ ڵ Ͼ ʽϴ.
				// ߰  ̴ ŭ ũ
				// ũ  = ü   - (  ̴ ù °  +  //   )
				pRich->SendMessage(EM_LINESCROLL, 0, nLines - nVisibleLine - 20 );

				g_arText.RemoveHead();
			}
			g_cs.Unlock();
			Sleep(1);
		}
	}
	return 0L;
}

void CDumpWindow::DumpString(const wchar_t *pszAdd)
{
	g_cs.Lock();
	g_arText.AddTail(pszAdd);
	g_cs.Unlock();
}

void CDumpWindow::SetDFont()
{
	CString Tmp_Font_Family = g_cOption.GetOptionString(L"FontFamily").c_str();
	int Tmp_Font_Size = g_cOption.GetOptionInt(L"FontSize");
	bool Tmp_Font_Bold = g_cOption.GetOptionBool(L"FontBold");

	if(Tmp_Font_Size != m_Font_Size ||
		Tmp_Font_Bold != m_Font_Bold ||
		Tmp_Font_Family != m_Font_Family)
	{
		Tmp_Font_Size = m_Font_Size;
		Tmp_Font_Bold = m_Font_Bold;
		Tmp_Font_Family = m_Font_Family;

		CFont TmpFont;

		int TmpBold=FW_NORMAL;
		if(m_Font_Bold)
			TmpBold=FW_BOLD;

		TmpFont.CreateFontW(m_Font_Size,0,0,0,TmpBold,0,0,0,0,0,0,1,0,m_Font_Family.GetString());

		g_cs.Lock();
		m_ctrRich.SetFont(&TmpFont);
		g_cs.Unlock();
	}
}
void CDumpWindow::OnDestroy()
{
	// !!!

	//Ʈ
	LOGFONT TmpFont;
	g_cs.Lock();
	m_ctrRich.GetFont()->GetLogFont(&TmpFont);

	g_cOption.SetOptionString(L"FontFamily",TmpFont.lfFaceName);
	g_cOption.SetOptionInt(L"FontSize",TmpFont.lfHeight);

	if(TmpFont.lfWeight==FW_BOLD)
		g_cOption.SetOptionInt(L"FontBold",true);
	else
		g_cOption.SetOptionInt(L"FontBold",false);

	//  
	GetWindowRect(m_Size);
	g_cOption.SetOptionInt(L"Pos",m_nWindowN,1,m_Size.left);
	g_cOption.SetOptionInt(L"Pos",m_nWindowN,2,m_Size.top);
	g_cOption.SetOptionInt(L"Pos",m_nWindowN,3,m_Size.right);
	g_cOption.SetOptionInt(L"Pos",m_nWindowN,4,m_Size.bottom);

	g_cs.Unlock();
	CDialog::OnDestroy();
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}
